#include <bits/stdc++.h>
using namespace std;
#define vt vector
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n>>q;
    vt<int> a(n);
    for(int i=0; i<n; i++){
        cin>>a[i];
    }
    while(q--){
        int l, r;
        cin>>n>>l>>r;
        cout<<r-l+1-(r%2)-(l%2);
    }
}
